class Distort {

  int dSizeX, dSizeY, peak;
  int oldMillis;
  int[] saveXY = new int[2];
  PGraphics pg;
  int pgX;
  int pgY;
  int randomValue;
  boolean dLine;

  Distort(int _dSizeX, int _dSizeY, int _peak, boolean _dLine)

  {
    dLine = _dLine;
    dSizeX = _dSizeX;
    dSizeY = _dSizeY;
    peak = _peak;
    pg = createGraphics(_dSizeX, _dSizeY, P2D);
    randomValue = int(random(500, 4000));
    oldMillis = -randomValue;
    pg.smooth();
  }

  void draw()

  {

    if (millis()-oldMillis >= randomValue)
    {
      if (dLine)
      {
        saveXY[0]=width/2;
        float gauss = (float)generator.nextGaussian()/2.0;
        if (gauss <= -1.0) {
          gauss = -1.0;
        }
        if (gauss >= 1.0) {
          gauss = 1.0;
        }
        //println(int((gauss+1.0)*height/2.0));
        saveXY[1]=int((gauss+1.0)*height/2.0);
      }
      else
      {
        saveXY[0]= int(random(0, 800));
        saveXY[1]= int(random(0, 800));
        dSizeX = int(random(50, maxDistSize));
        dSizeY = int(random(50, maxDistSize));
      }
      //println(saveXY);
      pg = createGraphics(dSizeX, dSizeY, P2D);
      //println(pg.width);
      randomValue = int(random(1000, 2000));
      oldMillis=millis();
    }
    full.loadPixels();
    pg.loadPixels();



    pgX=0;
    for ( int dX = saveXY[0]-pg.width/2; dX < saveXY[0]+pg.width/2; dX++)
    {
      pgY=0;
      for (int dY = saveXY[1]-pg.height/2; dY < saveXY[1]+pg.height/2; dY++)
      { 
        int dLoc = dX+maxDistSize/2 + (dY+maxDistSize/2) *full.width; 
        int pgLoc = pgX + pgY * pg.width;
        pg.pixels[pgLoc] = full.pixels[dLoc];

        // Start Zeichnen im Offscreen Buffer pg
        pgY++;
      }
      pgX++;
    }
    pg.updatePixels();

    image(pg, saveXY[0]-pg.width/2+random(-peak, peak), saveXY[1]-pg.height/2+random(-peak, peak));
  }
}


