class TimeArc {
 
  int xCord,yCord, arcRadius, arcValue,arcT;
  float arcScale;
  color c;
  LineText arcText;
  PGraphics arcFull;
  int arcWeight;
  int arcTimer;
  
  
  
 TimeArc(PGraphics _arcFull)
 {
   arcFull = _arcFull;
   xCord = 0;
   yCord = 0;
   arcRadius = 0;
   arcValue = 0;
   c = color(0,0,0);
   arcText = new LineText();
   arcScale = 1;
   arcWeight = 30;
   arcTimer = 0;
 }
 
 TimeArc(color _c,int _arcRadius, int _arcValue, int _arcT, float _arcScale)
 {
   xCord = 0;
   yCord = 0;
   arcRadius = _arcRadius;
   arcValue = _arcValue;
   arcT = _arcT;
   c = _c;
   arcScale = _arcScale;
   arcText = new LineText(c,arcRadius, arcRadius+10,arcValue,arcT,arcScale, arcWeight);
   
 }
 void update(color _c,int _arcRadius, int _arcValue, int _arcT, float _arcScale){
   xCord = 0;
   yCord = 0;
   arcRadius = _arcRadius;
   arcValue = _arcValue;
   arcT = _arcT;
   c = _c;
   arcScale = _arcScale;
   
 }
 
 void draw(){
  arcFull.smooth();
  arcFull.colorMode(HSB,360);
  arcFull.fill(c);
  arcFull.noStroke();
  if(arcValue > 360)
  {
     arcValue = arcValue -360;   
  }
  arcFull.noFill();
  arcFull.strokeWeight(arcWeight);
  arcFull.stroke(c);
  arcFull.arc(0, 0, arcRadius*2*arcScale, arcRadius*2*arcScale, 0, radians(arcValue));
  
  if (arcValue == 0)
  {
    arcTimer = 0;
  }
  
  if (arcTimer <=200)
{  
  arcFull.strokeWeight(1*arcScale);
  arcFull.stroke(360,0,360,360/20*(20-arcTimer));
  arcFull.arc(0, 0, arcRadius*2*arcScale+arcWeight, arcRadius*2*arcScale+arcWeight, 0, 2*PI);  
  arcTimer++;
  }
  
  arcText.update(c, arcRadius, arcRadius, radians(arcValue), arcT, arcScale, arcWeight);
  arcText.draw(); 
  /*
  arcFull.noStroke();
  arcFull.fill(360);
  arcFull.ellipse(0, 0, ((2*arcRadius)-20)*arcScale, ((2*arcRadius)-20)*arcScale); 
   */
 }
 
 
  
}
